---
title: "GET /v1/users/single | Documentation - Vemetric"
description: "Get user"
url: https://vemetric.com/docs/api/endpoints/get-v1-users-single
---

# Get user

Returns one user by id or identifier.

* * *

Method

GET

Path

/v1/users/single

This endpoint returns a single user from your project by `id` or `identifier`.

It’s possible to fetch anonymous, as well as [identified users](https://vemetric.com/docs/product-analytics/user-identification) with this endpoint.

## Headers

Authorization

required

Project API key (starts with `vem_`), created in the project settings on the API tab. Requests only return data of that key's project.

Example: `Bearer vem_xxxxxxxxxxxx`

## Query Parameters

id

string optional

Vemetric's internal user ID. You have to either provide `id` or `identifier`.

Example: `123`

identifier

string optional

User identifier value. You have to either provide `identifier` or `id`.

Example: `your-user-id`

## Responses

200 Success

application/json

`user`

Description

Resolved user row.

Type

object

`id`

Description

Vemetric's internal user ID.

Type

string

Example

"123"

* * *

`identifier`

Description

User identifier if available (the value you provided to identify the user).

Type

string | null

Example

"john@example.com"

* * *

`displayName`

Description

User display name if available.

Type

string | null

Example

"John Doe"

* * *

`country`

Description

ISO-3166 alpha-2 country code, or `null` when unknown.

Type

string | null

Example

"US"

* * *

`city`

Description

User city, or `null` when unknown.

Type

string | null

Example

"Berlin"

* * *

`lastSeenAt`

Description

UTC timestamp of the latest activity for this user within the selected period.

Type

string<pattern:^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}Z$> | null

Example

"2026-01-19T12:30:00Z"

* * *

`avatarUrl`

Description

Avatar URL if available.

Type

string | null

Example

"https://cdn.example.com/avatar.png"

* * *

`data`

Description

Data attributes collected for this user.

Type

object

Example

{"plan":"pro","company":"Vemetric"}

* * *

`anonymous`

Description

Whether the user is anonymous (not identified).

Type

boolean

Example

false

* * *

* * *

400 Bad request - invalid request payload or parameters

application/json

`error`

Description

Error details.

Type

object

`code`

Description

Machine-readable error code. `HTTP_ERROR` is returned for a malformed JSON body.

Type

"VALIDATION\_ERROR" | "HTTP\_ERROR"

* * *

`message`

Description

Human-readable error message.

Type

string

* * *

`details`

Description

Per-field validation issues. Only present for `VALIDATION_ERROR`.

Type

array<object>

Show nested properties (2)

`field`

Description

Path to the invalid request field.

Type

string

Example

"groupBy.0"

* * *

`message`

Description

Validation error message for the field.

Type

string

* * *

* * *

* * *

401 Unauthorized - missing, malformed, invalid or revoked API key

application/json

`error`

Description

Error details.

Type

object

`code`

Description

Machine-readable error code.

Type

"UNAUTHORIZED"

* * *

`message`

Description

Human-readable error message.

Type

string

* * *

* * *

404 User was not found

application/json

`error`

Description

Error details.

Type

object

`code`

Description

Machine-readable error code.

Type

"USER\_NOT\_FOUND"

* * *

`message`

Description

Human-readable error message.

Type

string

* * *

* * *

429 Rate limit exceeded - retry after the number of seconds in the Retry-After header

application/json

`error`

Description

Error details.

Type

object

`code`

Description

Machine-readable error code.

Type

"RATE\_LIMIT\_EXCEEDED"

* * *

`message`

Description

Human-readable error message.

Type

string

* * *

* * *

500 Unexpected internal error

application/json

`error`

Description

Error details.

Type

object

`code`

Description

Machine-readable error code.

Type

"INTERNAL\_ERROR"

* * *

`message`

Description

Human-readable error message.

Type

string

* * *

* * *
